<html>
<head>
<title>Ogre::FocusedShadowCameraSetup Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html">FocusedShadowCameraSetup</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::FocusedShadowCameraSetup Class Reference<div class="ingroups"><a class="el" href="group__Scene.html">Scene</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::FocusedShadowCameraSetup" --><!-- doxytag: inherits="Ogre::ShadowCameraSetup" -->
<p>Implements the uniform shadow mapping algorithm in focused mode.  
 <a href="classOgre_1_1FocusedShadowCameraSetup.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::FocusedShadowCameraSetup:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1FocusedShadowCameraSetup__inherit__graph.gif" border="0" usemap="#Ogre_1_1FocusedShadowCameraSetup_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1FocusedShadowCameraSetup_inherit__map" id="Ogre_1_1FocusedShadowCameraSetup_inherit__map">
<area shape="rect" id="node7" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm." alt="" coords="7,237,239,267"/><area shape="rect" id="node2" href="classOgre_1_1ShadowCameraSetup.html" title="This class allows you to plug in new ways to define the camera setup when rendering and projecting sh..." alt="" coords="31,83,215,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="60,5,185,35"/><area shape="rect" id="node9" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup." alt="" coords="12,315,233,344"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1FocusedShadowCameraSetup-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal class holding a point list representation of a convex body.  <a href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af4fec2364b3404a7738e9b5ede0710e7">FocusedShadowCameraSetup</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor.  <a href="#af4fec2364b3404a7738e9b5ede0710e7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#aa37dc46bc1cc5a65359c66fdb539b74c">~FocusedShadowCameraSetup</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default destructor.  <a href="#aa37dc46bc1cc5a65359c66fdb539b74c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a143f0b68859d6074732415c3591e3c24">getShadowCamera</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam, const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *vp, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *texCam, size_t iteration) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a uniform shadow camera with a focused view.  <a href="#a143f0b68859d6074732415c3591e3c24"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af57854c45cd48033da1cb28e316901dc">setUseAggressiveFocusRegion</a> (bool aggressive)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether or not to use the more aggressive approach to deciding on the focus region or not.  <a href="#af57854c45cd48033da1cb28e316901dc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a89fc1444a88d8c20c35ee50a8c518564">getUseAggressiveFocusRegion</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a7236f92a6006f84b7441adce882713df">calculateShadowMappingMatrix</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_view, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_proj, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *out_cam) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the standard shadow mapping matrix.  <a href="#a7236f92a6006f84b7441adce882713df"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af13f2303f0a347a74aaca487482d40ba">calculateB</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;receiverBB, <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *out_bodyB) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the intersection bodyB.  <a href="#af13f2303f0a347a74aaca487482d40ba"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a0706a0e7b7ec6aecf9639dbe5b9cc7a2">calculateLVS</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *out_LVS) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the bodyLVS.  <a href="#a0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a5a463b751319df295758fa832e9f8e2d">getLSProjViewDir</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;bodyLVS) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the projection view direction.  <a href="#a5a463b751319df295758fa832e9f8e2d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a023ab991324e937410c0b8bc654085e5">getNearCameraPoint_ws</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;viewMatrix, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;bodyLVS) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a valid near-point seen by the camera.  <a href="#a023ab991324e937410c0b8bc654085e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a1438dc104a74c79bbe98df922e31651b">transformToUnitCube</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;body) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled.  <a href="#a1438dc104a74c79bbe98df922e31651b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a2717983dfbfaff59191bb51fae350ece">buildViewMatrix</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;pos, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;dir, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;up) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Builds a view matrix.  <a href="#a2717983dfbfaff59191bb51fae350ece"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a0ebae20e4252d229af9524a8690ecc11">mTempFrustum</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Temporary preallocated frustum to set up a projection matrix in ::calculateShadowMappingMatrix()  <a href="#a0ebae20e4252d229af9524a8690ecc11"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a1cdb9e5c72f7bbb936b2ba84cf605787">mLightFrustumCamera</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Temporary preallocated camera to set up a light frustum for clipping in ::calculateB.  <a href="#a1cdb9e5c72f7bbb936b2ba84cf605787"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a113a55085b7c23a1004a4be9f3155c1c">mLightFrustumCameraCalculated</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#ac22ea363ab7fc61d60f0c1518015cb6b">mUseAggressiveRegion</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Use tighter focus region?  <a href="#ac22ea363ab7fc61d60f0c1518015cb6b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#ae784e0376eb99fa60f2c4a995ccd162e">mBodyB</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a84c5bc98d3d36f4e3f858d726d1cb19e">mPointListBodyB</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a69328121d415c6e9033ff0e3d7d21cd2">mPointListBodyLVS</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a2022a48e9e37aa409682d320233cfa09">msNormalToLightSpace</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Transform to or from light space as defined by Wimmer et al.  <a href="#a2022a48e9e37aa409682d320233cfa09"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a3c6218ad4ccccd28374444f1ecd2b3d5">msLightSpaceToNormal</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Implements the uniform shadow mapping algorithm in focused mode. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Differs from the default shadow mapping projection in that it focuses the shadow map on the visible areas of the scene. This results in better shadow map texel usage, at the expense of some 'swimming' of the shadow texture on receivers as the basis is constantly being reevaluated. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>Original implementation by Matthias Fink &lt;<a href="mailto:matthias.fink@web.de">matthias.fink@web.de</a>&gt;, 2006. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00057">57</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="af4fec2364b3404a7738e9b5ede0710e7"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::FocusedShadowCameraSetup" ref="af4fec2364b3404a7738e9b5ede0710e7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af4fec2364b3404a7738e9b5ede0710e7">Ogre::FocusedShadowCameraSetup::FocusedShadowCameraSetup</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Temporary frustum and camera set up here. </dd></dl>

</div>
</div>
<a class="anchor" id="aa37dc46bc1cc5a65359c66fdb539b74c"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::~FocusedShadowCameraSetup" ref="aa37dc46bc1cc5a65359c66fdb539b74c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#aa37dc46bc1cc5a65359c66fdb539b74c">Ogre::FocusedShadowCameraSetup::~FocusedShadowCameraSetup</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default destructor. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Temporary frustum and camera destroyed here. </dd></dl>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a2717983dfbfaff59191bb51fae350ece"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::buildViewMatrix" ref="a2717983dfbfaff59191bb51fae350ece" args="(const Vector3 &amp;pos, const Vector3 &amp;dir, const Vector3 &amp;up) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a2717983dfbfaff59191bb51fae350ece">Ogre::FocusedShadowCameraSetup::buildViewMatrix</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>dir</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>up</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Builds a view matrix. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Builds a standard view matrix out of a given position, direction and up vector. </dd></dl>

</div>
</div>
<a class="anchor" id="af13f2303f0a347a74aaca487482d40ba"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateB" ref="af13f2303f0a347a74aaca487482d40ba" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, const AxisAlignedBox &amp;receiverBB, PointListBody *out_bodyB) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af13f2303f0a347a74aaca487482d40ba">Ogre::FocusedShadowCameraSetup::calculateB</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&#160;</td>
          <td class="paramname"><em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&#160;</td>
          <td class="paramname"><em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td>
          <td class="paramname"><em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td>
          <td class="paramname"><em>receiverBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&#160;</td>
          <td class="paramname"><em>out_bodyB</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculates the intersection bodyB. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The intersection bodyB consists of the concatenation the cam frustum clipped by the scene bounding box followed by a convex hullification with the light's position and the clipping with the scene bounding box and the light frustum: ((V  S) + l)  S  L (: convex intersection, +: convex hull operation). For directional lights the bodyB is assembled out of the camera frustum clipped by the scene bounding box followed by the extrusion of all available bodyB points towards the negative light direction. The rays are intersected by a maximum bounding box and added to the bodyB points to form the final intersection bodyB point list. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sm,:</td><td>scene manager </td></tr>
    <tr><td class="paramname">cam,:</td><td>currently active camera </td></tr>
    <tr><td class="paramname">light,:</td><td>currently active light </td></tr>
    <tr><td class="paramname">sceneBB,:</td><td>scene bounding box for clipping operations </td></tr>
    <tr><td class="paramname">receiverAABB,:</td><td>bounding information for just the receivers </td></tr>
    <tr><td class="paramname">out_bodyB,:</td><td>final intersection bodyB point list </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateLVS" ref="a0706a0e7b7ec6aecf9639dbe5b9cc7a2" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, PointListBody *out_LVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a0706a0e7b7ec6aecf9639dbe5b9cc7a2">Ogre::FocusedShadowCameraSetup::calculateLVS</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&#160;</td>
          <td class="paramname"><em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&#160;</td>
          <td class="paramname"><em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td>
          <td class="paramname"><em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&#160;</td>
          <td class="paramname"><em>out_LVS</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculates the bodyLVS. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Calculates the bodyLVS which consists of the convex intersection operation affecting the light frustum, the view frustum, and the current scene bounding box is used to find suitable positions in the viewer's frustum to build the rotation matrix L_r. This matrix is applied after the projection matrix L_p to avoid an accidental flip of the frustum orientation for views tilted with respect to the shadow map. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">scene,:</td><td>holds all potential occluders / receivers as one single bounding box of the currently active scene node </td></tr>
    <tr><td class="paramname">cam,:</td><td>current viewer camera </td></tr>
    <tr><td class="paramname">light,:</td><td>current light </td></tr>
    <tr><td class="paramname">out_LVS,:</td><td>intersection body LVS (world coordinates) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7236f92a6006f84b7441adce882713df"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateShadowMappingMatrix" ref="a7236f92a6006f84b7441adce882713df" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, Matrix4 *out_view, Matrix4 *out_proj, Camera *out_cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a7236f92a6006f84b7441adce882713df">Ogre::FocusedShadowCameraSetup::calculateShadowMappingMatrix</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&#160;</td>
          <td class="paramname"><em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&#160;</td>
          <td class="paramname"><em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&#160;</td>
          <td class="paramname"><em>out_view</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&#160;</td>
          <td class="paramname"><em>out_proj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>out_cam</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Calculates the standard shadow mapping matrix. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Provides the view and projection matrix for standard shadow mapping. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>You can choose which things you want to have: view matrix and/or projection matrix and/or shadow camera. Passing a NULL value as parameter ignores the generation of this specific value. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sm,:</td><td>scene manager </td></tr>
    <tr><td class="paramname">cam,:</td><td>currently active camera </td></tr>
    <tr><td class="paramname">light,:</td><td>currently active light </td></tr>
    <tr><td class="paramname">out_view,:</td><td>calculated uniform view shadow mapping matrix (may be NULL) </td></tr>
    <tr><td class="paramname">out_proj,:</td><td>calculated uniform projection shadow mapping matrix (may be NULL) </td></tr>
    <tr><td class="paramname">out_cam,:</td><td>calculated uniform shadow camera (may be NULL) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5a463b751319df295758fa832e9f8e2d"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getLSProjViewDir" ref="a5a463b751319df295758fa832e9f8e2d" args="(const Matrix4 &amp;lightSpace, const Camera &amp;cam, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a5a463b751319df295758fa832e9f8e2d">Ogre::FocusedShadowCameraSetup::getLSProjViewDir</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&#160;</td>
          <td class="paramname"><em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&#160;</td>
          <td class="paramname"><em>bodyLVS</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the projection view direction. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>After the matrix L_p is applied the orientation of the light space may tilt for non-identity projections. To prevent a false shadow cast the real view direction is evaluated and applied to the light matrix L. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightSpace,:</td><td>matrix of the light space transformation </td></tr>
    <tr><td class="paramname">cam,:</td><td>current viewer camera </td></tr>
    <tr><td class="paramname">bodyLVS,:</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a023ab991324e937410c0b8bc654085e5"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getNearCameraPoint_ws" ref="a023ab991324e937410c0b8bc654085e5" args="(const Matrix4 &amp;viewMatrix, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a023ab991324e937410c0b8bc654085e5">Ogre::FocusedShadowCameraSetup::getNearCameraPoint_ws</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>viewMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&#160;</td>
          <td class="paramname"><em>bodyLVS</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a valid near-point seen by the camera. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Returns a point that is situated near the camera by analyzing the bodyLVS that contains all the relevant scene space in front of the light and the camera in a point list array. The view matrix is relevant because the nearest point in front of the camera should be determined. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">viewMatrix,:</td><td>view matrix of the current camera </td></tr>
    <tr><td class="paramname">bodyLVS,:</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a143f0b68859d6074732415c3591e3c24"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getShadowCamera" ref="a143f0b68859d6074732415c3591e3c24" args="(const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam, size_t iteration) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a143f0b68859d6074732415c3591e3c24">Ogre::FocusedShadowCameraSetup::getShadowCamera</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&#160;</td>
          <td class="paramname"><em>vp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>texCam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>iteration</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a uniform shadow camera with a focused view. </p>

<p>Implements <a class="el" href="classOgre_1_1ShadowCameraSetup.html#aef69374906ff048997e187101858f856">Ogre::ShadowCameraSetup</a>.</p>

<p>Reimplemented in <a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a88062e37040f690f8c5609b9483f031f">Ogre::LiSPSMShadowCameraSetup</a>, and <a class="el" href="classOgre_1_1PSSMShadowCameraSetup.html#ad83d397011ff4c44da4af625d1c28e64">Ogre::PSSMShadowCameraSetup</a>.</p>

</div>
</div>
<a class="anchor" id="a89fc1444a88d8c20c35ee50a8c518564"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getUseAggressiveFocusRegion" ref="a89fc1444a88d8c20c35ee50a8c518564" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a89fc1444a88d8c20c35ee50a8c518564">Ogre::FocusedShadowCameraSetup::getUseAggressiveFocusRegion</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00280">280</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="af57854c45cd48033da1cb28e316901dc"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::setUseAggressiveFocusRegion" ref="af57854c45cd48033da1cb28e316901dc" args="(bool aggressive)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#af57854c45cd48033da1cb28e316901dc">Ogre::FocusedShadowCameraSetup::setUseAggressiveFocusRegion</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>aggressive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether or not to use the more aggressive approach to deciding on the focus region or not. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>There are 2 approaches that can be used to define the focus region, the more aggressive way introduced by Wimmer et al, or the original way as described in Stamminger et al. Wimmer et al's way tends to come up with a tighter focus region but in rare cases (mostly highly glancing angles) can cause some shadow casters to be clipped incorrectly. By default the more aggressive approach is used since it leads to significantly better results in most cases, but if you experience clipping issues, you can use the less aggressive version. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">aggressive</td><td>True to use the more aggressive approach, false otherwise. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00278">278</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1438dc104a74c79bbe98df922e31651b"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::transformToUnitCube" ref="a1438dc104a74c79bbe98df922e31651b" args="(const Matrix4 &amp;m, const PointListBody &amp;body) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a1438dc104a74c79bbe98df922e31651b">Ogre::FocusedShadowCameraSetup::transformToUnitCube</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&#160;</td>
          <td class="paramname"><em>body</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Transforms a given point list body object with the matrix m and then maps its extends to a (-1,-1,-1) / (+1,+1,+1) unit cube </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">m,:</td><td>transformation matrix applied on the point list body </td></tr>
    <tr><td class="paramname">body,:</td><td>contains the points of the extends of all valid scene elements which are mapped to the unit cube </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ae784e0376eb99fa60f2c4a995ccd162e"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mBodyB" ref="ae784e0376eb99fa60f2c4a995ccd162e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#ae784e0376eb99fa60f2c4a995ccd162e">Ogre::FocusedShadowCameraSetup::mBodyB</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00144">144</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1cdb9e5c72f7bbb936b2ba84cf605787"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mLightFrustumCamera" ref="a1cdb9e5c72f7bbb936b2ba84cf605787" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Camera.html">Camera</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a1cdb9e5c72f7bbb936b2ba84cf605787">Ogre::FocusedShadowCameraSetup::mLightFrustumCamera</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Temporary preallocated camera to set up a light frustum for clipping in ::calculateB. </p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00077">77</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a113a55085b7c23a1004a4be9f3155c1c"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mLightFrustumCameraCalculated" ref="a113a55085b7c23a1004a4be9f3155c1c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a113a55085b7c23a1004a4be9f3155c1c">Ogre::FocusedShadowCameraSetup::mLightFrustumCameraCalculated</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00078">78</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a84c5bc98d3d36f4e3f858d726d1cb19e"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mPointListBodyB" ref="a84c5bc98d3d36f4e3f858d726d1cb19e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a84c5bc98d3d36f4e3f858d726d1cb19e">Ogre::FocusedShadowCameraSetup::mPointListBodyB</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00145">145</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a69328121d415c6e9033ff0e3d7d21cd2"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mPointListBodyLVS" ref="a69328121d415c6e9033ff0e3d7d21cd2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a69328121d415c6e9033ff0e3d7d21cd2">Ogre::FocusedShadowCameraSetup::mPointListBodyLVS</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00146">146</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3c6218ad4ccccd28374444f1ecd2b3d5"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::msLightSpaceToNormal" ref="a3c6218ad4ccccd28374444f1ecd2b3d5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a3c6218ad4ccccd28374444f1ecd2b3d5">Ogre::FocusedShadowCameraSetup::msLightSpaceToNormal</a><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00068">68</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2022a48e9e37aa409682d320233cfa09"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::msNormalToLightSpace" ref="a2022a48e9e37aa409682d320233cfa09" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a2022a48e9e37aa409682d320233cfa09">Ogre::FocusedShadowCameraSetup::msNormalToLightSpace</a><code> [static, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Transform to or from light space as defined by Wimmer et al. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Point and spot lights need to be converted to directional lights to enable a 1:1 light mapping. Otherwise a directional light may become a point light or a point sink (opposite of a light source) or point/spot lights may become directional lights or light sinks. The light direction is always -y. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00067">67</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0ebae20e4252d229af9524a8690ecc11"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mTempFrustum" ref="a0ebae20e4252d229af9524a8690ecc11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a0ebae20e4252d229af9524a8690ecc11">Ogre::FocusedShadowCameraSetup::mTempFrustum</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Temporary preallocated frustum to set up a projection matrix in ::calculateShadowMappingMatrix() </p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00073">73</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac22ea363ab7fc61d60f0c1518015cb6b"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mUseAggressiveRegion" ref="ac22ea363ab7fc61d60f0c1518015cb6b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#ac22ea363ab7fc61d60f0c1518015cb6b">Ogre::FocusedShadowCameraSetup::mUseAggressiveRegion</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Use tighter focus region? </p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html#l00081">81</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCameraSetupFocused_8h_source.html">OgreShadowCameraSetupFocused.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:07
</p>
</body>
</html>
